com.io7m.jtensors.bytebuffered.parameterized

## Class PMatrixByteBufferedM3x3F<T0,T1>

- java.lang.Object
- - com.io7m.jtensors.bytebuffered.parameterized.PMatrixByteBufferedM3x3F<T0,T1>

- Type Parameters:
    `T0` - A phantom type parameter
    `T1` - A phantom type parameter
  All Implemented Interfaces:
    ByteBufferedType, PMatrixByteBuffered3x3FType<T0,T1>, Matrix3x3FType, MatrixReadable2x2FType, MatrixReadable3x3FType, MatrixReadableFType, MatrixWritable2x2FType, MatrixWritable3x3FType, MatrixWritableFType, PMatrix3x3FType<T0,T1>, PMatrixReadable3x3FType<T0,T1>, PMatrixReadableFType<T0,T1>, PMatrixWritable3x3FType<T0,T1>, PMatrixWritableFType<T0,T1>

      public final class PMatrixByteBufferedM3x3F<T0,T1>
      extends Object
      implements PMatrixByteBuffered3x3FType<T0,T1>

  A 3x3 matrix type with `float` elements, packed into a `ByteBuffer`.

  Values of this type cannot be accessed safely from multiple threads without explicit synchronization.

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(Object obj)`
    `long` | `getByteOffset()`
    `float` | `getR0C0F()`
    `float` | `getR0C1F()`
    `float` | `getR0C2F()`
    `float` | `getR1C0F()`
    `float` | `getR1C1F()`
    `float` | `getR1C2F()`
    `float` | `getR2C0F()`
    `float` | `getR2C1F()`
    `float` | `getR2C2F()`
    `<V extends VectorWritable2FType> void` | `getRow2F(int row, V out)` Retrieve row `row`, saving the result to `out`.
    `<V extends VectorWritable2FType> void` | `getRow2FUnsafe(int row, V out)` Retrieve row `row`, saving the result to `out`.
    `<V extends VectorWritable3FType> void` | `getRow3F(int row, V out)` Retrieve row `row`, saving the result to `out`.
    `<V extends VectorWritable3FType> void` | `getRow3FUnsafe(int row, V out)` Retrieve row `row`, saving the result to `out`.
    `float` | `getRowColumnF(int row, int column)`
    `int` | `hashCode()`
    `static <T0,T1> PMatrixByteBuffered3x3FType<T0,T1>` | `newMatrixFromByteBuffer(ByteBuffer b, long byte_offset)` Return a new matrix that is backed by whatever data is at byte offset `byte_offset` in the byte buffer .
    `void` | `setByteOffset(long b)` Set the base byte offset of this value.
    `void` | `setR0C0F(float x)` Set row 0, column 0 of the matrix to `x`.
    `void` | `setR0C1F(float x)` Set row 0, column 1 of the matrix to `x`.
    `void` | `setR0C2F(float x)` Set row 0, column 2 of the matrix to `x`.
    `void` | `setR1C0F(float x)` Set row 1, column 0 of the matrix to `x`.
    `void` | `setR1C1F(float x)` Set row 1, column 1 of the matrix to `x`.
    `void` | `setR1C2F(float x)` Set row 1, column 2 of the matrix to `x`.
    `void` | `setR2C0F(float x)` Set row 2, column 0 of the matrix to `x`.
    `void` | `setR2C1F(float x)` Set row 2, column 1 of the matrix to `x`.
    `void` | `setR2C2F(float x)` Set row 2, column 2 of the matrix to `x`.
    `void` | `setRowColumnF(int row, int column, float value)` Set the value from the matrix at row `row`, column `column` to `value`.
    `void` | `setRowWith2F(int row, VectorReadable2FType v)` Set row `row` of the matrix to `v`.
    `void` | `setRowWith2FUnsafe(int row, VectorReadable2FType v)` Set row `row` of the matrix to `v`.
    `void` | `setRowWith3F(int row, VectorReadable3FType v)` Set row `row` of the matrix to `v`.
    `void` | `setRowWith3FUnsafe(int row, VectorReadable3FType v)` Set row `row` of the matrix to `v`.
    `String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### newMatrixFromByteBuffer

          public static <T0,T1> PMatrixByteBuffered3x3FType<T0,T1> newMatrixFromByteBuffer(ByteBuffer b,
                                                                                           long byte_offset)

      Return a new matrix that is backed by whatever data is at byte offset `byte_offset` in the byte buffer .

      No initialization of the data is performed.

      Type Parameters:
        `T0` - A phantom type parameter
        `T1` - A phantom type parameter
      Parameters:
        `b` - The byte buffer
        `byte_offset` - A byte offset
      Returns:
        A new buffered matrix

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### equals

          public boolean equals(@Nullable
                                Object obj)

      Overrides:
        `equals` in class `Object`

    - #### getRow3F

          public <V extends VectorWritable3FType> void getRow3F(int row,
                                                                V out)

      Description copied from interface: `MatrixReadable3x3FType`
      Retrieve row `row`, saving the result to `out`.
      Specified by:
        `getRow3F` in interface `MatrixReadable3x3FType`
      Type Parameters:
        `V` - The precise type of writable vector.
      Parameters:
        `row` - The index of the row, starting at `0`.
        `out` - The output vector.

    - #### getRow3FUnsafe

          public <V extends VectorWritable3FType> void getRow3FUnsafe(int row,
                                                                      V out)

      Description copied from interface: `MatrixReadable3x3FType`
      Retrieve row `row`, saving the result to `out`. No bounds checking is performed for `row`, and out-of-bounds values result in undefined behaviour.
      Specified by:
        `getRow3FUnsafe` in interface `MatrixReadable3x3FType`
      Type Parameters:
        `V` - The precise type of writable vector.
      Parameters:
        `row` - The index of the row, starting at `0`.
        `out` - The output vector.

    - #### getR0C2F

          public float getR0C2F()

      Specified by:
        `getR0C2F` in interface `MatrixReadable3x3FType`
      Returns:
        The value at row 0, column 2

    - #### setR0C2F

          public void setR0C2F(float x)

      Description copied from interface: `MatrixWritable3x3FType`
      Set row 0, column 2 of the matrix to `x`.
      Specified by:
        `setR0C2F` in interface `MatrixWritable3x3FType`
      Parameters:
        `x` - The value

    - #### getR1C2F

          public float getR1C2F()

      Specified by:
        `getR1C2F` in interface `MatrixReadable3x3FType`
      Returns:
        The value at row 1, column 2

    - #### setR1C2F

          public void setR1C2F(float x)

      Description copied from interface: `MatrixWritable3x3FType`
      Set row 1, column 2 of the matrix to `x`.
      Specified by:
        `setR1C2F` in interface `MatrixWritable3x3FType`
      Parameters:
        `x` - The value

    - #### getR2C0F

          public float getR2C0F()

      Specified by:
        `getR2C0F` in interface `MatrixReadable3x3FType`
      Returns:
        The value at row 2, column 0

    - #### setR2C0F

          public void setR2C0F(float x)

      Description copied from interface: `MatrixWritable3x3FType`
      Set row 2, column 0 of the matrix to `x`.
      Specified by:
        `setR2C0F` in interface `MatrixWritable3x3FType`
      Parameters:
        `x` - The value

    - #### getR2C1F

          public float getR2C1F()

      Specified by:
        `getR2C1F` in interface `MatrixReadable3x3FType`
      Returns:
        The value at row 2, column 1

    - #### setR2C1F

          public void setR2C1F(float x)

      Description copied from interface: `MatrixWritable3x3FType`
      Set row 2, column 1 of the matrix to `x`.
      Specified by:
        `setR2C1F` in interface `MatrixWritable3x3FType`
      Parameters:
        `x` - The value

    - #### getR2C2F

          public float getR2C2F()

      Specified by:
        `getR2C2F` in interface `MatrixReadable3x3FType`
      Returns:
        The value at row 2, column 2

    - #### setR2C2F

          public void setR2C2F(float x)

      Description copied from interface: `MatrixWritable3x3FType`
      Set row 2, column 2 of the matrix to `x`.
      Specified by:
        `setR2C2F` in interface `MatrixWritable3x3FType`
      Parameters:
        `x` - The value

    - #### getRow2F

          public <V extends VectorWritable2FType> void getRow2F(int row,
                                                                V out)

      Description copied from interface: `MatrixReadable2x2FType`
      Retrieve row `row`, saving the result to `out`.
      Specified by:
        `getRow2F` in interface `MatrixReadable2x2FType`
      Type Parameters:
        `V` - The precise type of writable vector.
      Parameters:
        `row` - The index of the row, starting at `0`.
        `out` - The output vector.

    - #### getRow2FUnsafe

          public <V extends VectorWritable2FType> void getRow2FUnsafe(int row,
                                                                      V out)

      Description copied from interface: `MatrixReadable2x2FType`
      Retrieve row `row`, saving the result to `out`. No bounds checking is performed for `row`, and out-of-bounds values result in undefined behaviour.
      Specified by:
        `getRow2FUnsafe` in interface `MatrixReadable2x2FType`
      Type Parameters:
        `V` - The precise type of writable vector.
      Parameters:
        `row` - The index of the row, starting at `0`.
        `out` - The output vector.

    - #### getR0C0F

          public float getR0C0F()

      Specified by:
        `getR0C0F` in interface `MatrixReadable2x2FType`
      Returns:
        The value at row 0, column 0

    - #### setR0C0F

          public void setR0C0F(float x)

      Description copied from interface: `MatrixWritable2x2FType`
      Set row 0, column 0 of the matrix to `x`.
      Specified by:
        `setR0C0F` in interface `MatrixWritable2x2FType`
      Parameters:
        `x` - The value

    - #### getR1C0F

          public float getR1C0F()

      Specified by:
        `getR1C0F` in interface `MatrixReadable2x2FType`
      Returns:
        The value at row 1, column 0

    - #### setR1C0F

          public void setR1C0F(float x)

      Description copied from interface: `MatrixWritable2x2FType`
      Set row 1, column 0 of the matrix to `x`.
      Specified by:
        `setR1C0F` in interface `MatrixWritable2x2FType`
      Parameters:
        `x` - The value

    - #### getR0C1F

          public float getR0C1F()

      Specified by:
        `getR0C1F` in interface `MatrixReadable2x2FType`
      Returns:
        The value at row 0, column 1

    - #### setR0C1F

          public void setR0C1F(float x)

      Description copied from interface: `MatrixWritable2x2FType`
      Set row 0, column 1 of the matrix to `x`.
      Specified by:
        `setR0C1F` in interface `MatrixWritable2x2FType`
      Parameters:
        `x` - The value

    - #### getR1C1F

          public float getR1C1F()

      Specified by:
        `getR1C1F` in interface `MatrixReadable2x2FType`
      Returns:
        The value at row 1, column 1

    - #### setR1C1F

          public void setR1C1F(float x)

      Description copied from interface: `MatrixWritable2x2FType`
      Set row 1, column 1 of the matrix to `x`.
      Specified by:
        `setR1C1F` in interface `MatrixWritable2x2FType`
      Parameters:
        `x` - The value

    - #### getRowColumnF

          public float getRowColumnF(int row,
                                     int column)

      Specified by:
        `getRowColumnF` in interface `MatrixReadableFType`
      Parameters:
        `row` - The row
        `column` - The column
      Returns:
        The value from the matrix at row `row` , column `column`.

    - #### setRowWith3F

          public void setRowWith3F(int row,
                                   VectorReadable3FType v)

      Description copied from interface: `MatrixWritable3x3FType`
      Set row `row` of the matrix to `v`.
      Specified by:
        `setRowWith3F` in interface `MatrixWritable3x3FType`
      Parameters:
        `row` - The row index
        `v` - The row vector

    - #### setRowWith3FUnsafe

          public void setRowWith3FUnsafe(int row,
                                         VectorReadable3FType v)

      Description copied from interface: `MatrixWritable3x3FType`
      Set row `row` of the matrix to `v`. No bounds checking is performed for `row`, and out-of-bounds values result in undefined behaviour.
      Specified by:
        `setRowWith3FUnsafe` in interface `MatrixWritable3x3FType`
      Parameters:
        `row` - The row index
        `v` - The row vector

    - #### setRowWith2F

          public void setRowWith2F(int row,
                                   VectorReadable2FType v)

      Description copied from interface: `MatrixWritable2x2FType`
      Set row `row` of the matrix to `v`.
      Specified by:
        `setRowWith2F` in interface `MatrixWritable2x2FType`
      Parameters:
        `row` - The row index
        `v` - The row vector

    - #### setRowWith2FUnsafe

          public void setRowWith2FUnsafe(int row,
                                         VectorReadable2FType v)

      Description copied from interface: `MatrixWritable2x2FType`
      Set row `row` of the matrix to `v`. No bounds checking is performed for `row`, and out-of-bounds values result in undefined behaviour.
      Specified by:
        `setRowWith2FUnsafe` in interface `MatrixWritable2x2FType`
      Parameters:
        `row` - The row index
        `v` - The row vector

    - #### setRowColumnF

          public void setRowColumnF(int row,
                                    int column,
                                    float value)

      Description copied from interface: `MatrixWritableFType`
      Set the value from the matrix at row `row`, column `column` to `value`.
      Specified by:
        `setRowColumnF` in interface `MatrixWritableFType`
      Parameters:
        `row` - The row
        `column` - The column
        `value` - The value

    - #### getByteOffset

          public long getByteOffset()

      Specified by:
        `getByteOffset` in interface `ByteBufferedType`
      Returns:
        The base byte offset of this value

    - #### setByteOffset

          public void setByteOffset(long b)

      Description copied from interface: `ByteBufferedType`

      Set the base byte offset of this value.

      Must be non-negative.

      Specified by:
        `setByteOffset` in interface `ByteBufferedType`
      Parameters:
        `b` - The offset in bytes

Copyright © 2015 <code@io7m.com> http://io7m.com